﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;
using CommonBehaviors.Actions;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace Tricks
{
    public partial class Routine
    {
        

        #region AlwaysStealth()

        public DateTime LastStealth;
        public DateTime LastStealthCheck;

        public Composite AlwaysStealth()
        {
            LastStealthCheck = DateTime.Now;

            return
                new Decorator(
                ret =>
                    EnableAlwaysStealth &&
                    !StyxWoW.Me.Combat &&
                    !HasFlag(StyxWoW.Me) &&
                    !StyxWoW.Me.Mounted &&
                    !StyxWoW.Me.HasAura("Stealth") &&
                    (LastStealth  + TimeSpan.FromMilliseconds(1500)) < DateTime.Now &&
                    (LastStealthCheck + TimeSpan.FromMilliseconds(LastStealthCheckMS)) < DateTime.Now &&
                    (!HasDOTs(StyxWoW.Me) || (IsAttackable(StyxWoW.Me.CurrentTarget) && StyxWoW.Me.CurrentTarget.Distance < 15)) &&
                    SpellManager.CanCast("Stealth"),

                        new Action(delegate
                        {
                            SpellManager.Cast("Stealth");
                            Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Stealth");
                            LastStealth = DateTime.Now;
                        }
                        )
            );
        }
        #endregion
        #region Ambush
        public Composite Ambush()
        {
            return
            new Decorator(ret =>
                StyxWoW.Me.Combat &&
                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.IsBehind(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.CurrentEnergy >= 35 && 
                !IsImmune(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                
                SpellManager.CanCast("Ambush"),

                        new Action(delegate
                        {
                            SpellManager.Cast("Ambush");
                            Logging.Write(StyxWoW.Me.CurrentEnergy + "energy: Ambushing on " + StyxWoW.Me.CurrentTarget.Name);
                        }
                        )
            );
        }

        #endregion
        #region Backstab
        public Composite Backstab()
        {
            return
            new Decorator(ret =>
                StyxWoW.Me.Combat &&
                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                StyxWoW.Me.ComboPoints < 5 &&
                !StyxWoW.Me.HasAura("Stealth") &&
                StyxWoW.Me.IsBehind(StyxWoW.Me.CurrentTarget) &&
                SpellManager.CanCast("Backstab") &&
                !IsImmune(StyxWoW.Me.CurrentTarget),

                        new Action(delegate
                            {
                                SpellManager.Cast("Backstab");
                                Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Backstab " + StyxWoW.Me.CurrentTarget.Name);
                            }
                        )
            );
        }
        
        #endregion
        #region Dismantle()
        public Composite Dismantle()
        {
            return new Decorator(
                ret =>
                    StyxWoW.Me.Combat &&
                    IsAttackable(StyxWoW.Me.CurrentTarget) &&
                    StyxWoW.Me.CurrentTarget.IsPlayer &&
                    StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                    SpellManager.CanCast("Dismantle") &&
                    (
                        (StyxWoW.Me.CurrentTarget.Class == WoWClass.Warrior && StyxWoW.Me.CurrentTarget.HasAura("Avatar")) ||
                        (StyxWoW.Me.CurrentTarget.Class == WoWClass.Warrior && StyxWoW.Me.CurrentTarget.HasAura("Bloodbath")) ||
                        (StyxWoW.Me.CurrentTarget.Class == WoWClass.Warrior && StyxWoW.Me.CurrentTarget.HasAura("Recklessness")) ||
                        (StyxWoW.Me.CurrentTarget.Class == WoWClass.Rogue && StyxWoW.Me.CurrentTarget.HasAura("Shadow Dance")) ||
                        (StyxWoW.Me.CurrentTarget.Class == WoWClass.Rogue && StyxWoW.Me.CurrentTarget.HasAura("Shadow Blades")) ||
                        (StyxWoW.Me.CurrentTarget.Class == WoWClass.Rogue && StyxWoW.Me.CurrentTarget.HasAura("Killing Spree")) ||
                        (StyxWoW.Me.CurrentTarget.Class == WoWClass.Rogue && StyxWoW.Me.CurrentTarget.HasAura("Incarnation: King of the Jungle")) ||
                        (StyxWoW.Me.CurrentTarget.Class == WoWClass.DeathKnight && StyxWoW.Me.CurrentTarget.HasAura("Vampiric Blood"))
                    ),
                new Action(delegate
                {
                    SpellManager.Cast("Dismantle");
                    Logging.Write(StyxWoW.Me.HealthPercent + "% - Dismantled: " + StyxWoW.Me.CurrentTarget.Name);
                }
                )
            );
        }
        #endregion
        #region Eviscerate()
        public Composite Eviscerate()
        {
            return
            new Decorator(ret =>
                SpellManager.CanCast("Eviscerate"),

                        new Action(delegate
                        {
                            SpellManager.Cast("Eviscerate");
                            Logging.Write(StyxWoW.Me.HealthPercent + "% - Hotkey Eviscerate");
                        }
                        )
            );
        }

        #endregion
        #region Finishers()
        public Composite Finishers()
        {
            return
                new Decorator(
                    ret =>
                        EnableFinishers &&
                        IsAttackable(StyxWoW.Me.CurrentTarget),


                        new PrioritySelector(

                            //KIDNEY SHOT
                            new Decorator(ret =>
                                EnableAutoKidney &&
                                StyxWoW.Me.Combat &&
                                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                                !IsStunned(StyxWoW.Me.CurrentTarget) &&
                                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                                SpellManager.CanCast("Kidney Shot") &&
                                StyxWoW.Me.ComboPoints == 5,

                                        new Action(delegate
                                        {
                                            SpellManager.Cast("Kidney Shot");
                                            Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "kidney shot on " + StyxWoW.Me.CurrentTarget);
                                        })),

                            //SLICE AND DICE
                            new Decorator(ret =>
                                EnableKeepSliceAndDice &&
                                StyxWoW.Me.Combat &&
                                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                                MyDebuffTime("Slice and Dice", StyxWoW.Me) < 2 &&
                                StyxWoW.Me.ComboPoints >= SliceAndDiceComboPointsMin &&
                                StyxWoW.Me.ComboPoints <= SliceAndDiceComboPointsMax &&
                                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange,

                                        new Action(delegate
                                        {
                                            SpellManager.Cast("Slice and Dice");
                                            Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Slice and Dice");
                                        })
                            ),



                            //RECUPERATE
                            new Decorator(ret =>
                                EnableKeepRecuperate &&
                                !HasMyAura("Recuperate", StyxWoW.Me) &&
                                StyxWoW.Me.HealthPercent < 100 &&
                                StyxWoW.Me.ComboPoints >= RecuperateComboPoints,

                                        new Action(delegate
                                        {
                                            SpellManager.Cast("Recuperate");
                                            Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Recuperate");
                                        })
                            ),


                            //RUPTURE
                            new Decorator(ret =>
                                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                                StyxWoW.Me.Combat &&
                                (MyDebuffTime("Rupture", StyxWoW.Me.CurrentTarget) < 1 && !StyxWoW.Me.CurrentTarget.HasAura("Garrote")) &&
                                //!StyxWoW.Me.HasAura("Subterfuge") &&
                                StyxWoW.Me.ComboPoints >= 2 &&
                                StyxWoW.Me.ComboPoints <= 5 &&
                                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                                SpellManager.CanCast("Rupture"),

                                        new Action(delegate
                                        {
                                            SpellManager.Cast("Rupture");
                                            Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Rupture on " + StyxWoW.Me.CurrentTarget.Name);
                                        })
                            ),


                            //EVISCERATE
                            new Decorator(ret =>
                                EnableEviscerate &&
                                StyxWoW.Me.Combat &&
                                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                                SpellManager.CanCast("Eviscerate") &&
                                ((StyxWoW.Me.ComboPoints >= 1 && StyxWoW.Me.CurrentTarget.CurrentHealth <= 8500) ||
                                (StyxWoW.Me.ComboPoints >= 2 && StyxWoW.Me.CurrentTarget.CurrentHealth <= 18000) ||
                                (StyxWoW.Me.ComboPoints >= 3 && StyxWoW.Me.CurrentTarget.CurrentHealth <= 27000) ||
                                (StyxWoW.Me.ComboPoints >= 4 && StyxWoW.Me.CurrentTarget.CurrentHealth <= 35000) ||
                                (StyxWoW.Me.ComboPoints >= 5)), //&& !SpellManager.CanCast("Kidney Shot")

                                        new Action(delegate
                                        {
                                            SpellManager.Cast("Eviscerate");
                                            Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Eviscerate on " + StyxWoW.Me.CurrentTarget);
                                        })
                            )
                        )
                );
        }

        #endregion
        #region Feint()
        public Composite Feint()
        {
            return
            new Decorator(ret =>
                EnableAutoFeint &&
                !StyxWoW.Me.HasAura("Stealth") &&
                MyDebuffTime("Feint", StyxWoW.Me) < 1 &&
                EnemiesTargetingMe.Count() > 1 &&
                SpellManager.CanCast("Feint"),


                        new Action(delegate
                        {
                            SpellManager.Cast("Feint");
                            Logging.Write("Feint.");
                        }
                        )
            );
        }

        #endregion
        #region GetKeyState
        [DllImport("user32.dll")]
        internal static extern short GetAsyncKeyState(Keys vKey);
        #endregion
        #region GetSpellCooldown
        public static TimeSpan GetSpellCooldown(string spell)
        {
            SpellFindResults results;
            if (SpellManager.FindSpell(spell, out results))
            {
                if (results.Override != null)
                    return results.Override.CooldownTimeLeft;
                return results.Original.CooldownTimeLeft;
            }


            return TimeSpan.MaxValue;
        }
        #endregion
        #region Gouge()
        public Composite Gouge()
        {
            return
            new Decorator(ret =>
                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                SpellManager.CanCast("Gouge") &&
                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                !StyxWoW.Me.IsBehind(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.HasAura("Stealth") &&
                !IsStunned(StyxWoW.Me.CurrentTarget) &&
                !HasDOTs(StyxWoW.Me.CurrentTarget),


                        new Action(delegate
                        {
                            SpellManager.Cast("Gouge");
                            Logging.Write("Gouged " + StyxWoW.Me.CurrentTarget.Name);
                        }
                        )
            );
        }

        #endregion
        #region HasMyAura
        public static bool HasMyAura(string SpellName, WoWUnit Player)
        {
            try
            {
                if (!Player.HasAura(SpellName)) return false;
                if (!Player.ActiveAuras[SpellName].IsActive) return false;
                if (Player.ActiveAuras[SpellName].CreatorGuid != StyxWoW.Me.Guid) return false;

                return true;
            }
            catch (Exception)
            {
                return false;
            }
        }
        #endregion
        #region HasFlag()
        private static bool HasFlag(WoWUnit unit)
        {
            return unit != null && (unit.HasAura("Alliance Flag") || unit.HasAura("Horde Flag")
                                    || unit.HasAura("Netherstorm Flag") || unit.HasAura("Orb of Power"));
        }
        #endregion
        #region Hemorrhage
        public Composite Hemorrhage()
        {
            return
            new Decorator(ret =>
                StyxWoW.Me.CurrentTarget != null &&
                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.Combat &&
                !IsImmune(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.ComboPoints < 5 &&
                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                !StyxWoW.Me.HasAura("Stealth") &&
                (!StyxWoW.Me.IsBehind(StyxWoW.Me.CurrentTarget)) && // || MyDebuffTime("Hemorrhage", StyxWoW.Me.CurrentTarget) <= 2) &&
                SpellManager.CanCast("Hemorrhage"),
                
                        new Action(delegate
                        {
                            SpellManager.Cast("Hemorrhage");
                            Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Hemorrhage " + StyxWoW.Me.CurrentTarget.Name);
                        }
                        )
            );
        }

        #endregion
        #region Hold()
        public Composite Hold()
        {
            return
                new PrioritySelector(

                    new Action(delegate { Logging.Write("Holding"); })

                    );

        }


        #endregion
        #region Hotkeys()
        public Composite Hotkeys()
        {
            return
                new PrioritySelector(
                new Decorator(ret => GetAsyncKeyState(Keys.V) != 0, Hold()),
                new Decorator(ret => GetAsyncKeyState(Keys.H) != 0, ToggleEnableAutoStealth())

                //info on keybinds here.  it is case sensitive http://msdn.microsoft.com/en-us/library/system.windows.forms.keys.aspx

                );
        }
        #endregion
        #region Interrupts()

        public DateTime LastInterrupt;

        public Composite Interrupts()
        {
            return
                new PrioritySelector(
                            
                    //KICK
                    new Decorator(
                    ret =>
                        EnableInterrupting &&
                        EnableKick &&
                        IsAttackable(StyxWoW.Me.CurrentTarget) &&
                        StyxWoW.Me.CurrentTarget.IsCasting &&
                        StyxWoW.Me.CurrentTarget.CanInterruptCurrentSpellCast &&
                        StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                        StyxWoW.Me.CurrentTarget.CurrentCastTimeLeft.TotalMilliseconds < CastTimeLeftInMS &&
                        SpellManager.CanCast("Kick") &&
                        !InterruptImmune(StyxWoW.Me.CurrentTarget) &&
                        !IsCrowdControlled(StyxWoW.Me) &&
                        LastInterrupt + TimeSpan.FromMilliseconds(500) < DateTime.Now,

                        new Action(delegate
                        {
                            SpellManager.Cast("Kick");
                            Logging.Write("Kick interrupt on " + StyxWoW.Me.CurrentTarget.Name + " with " + StyxWoW.Me.CurrentTarget.CurrentCastTimeLeft.TotalMilliseconds.ToString() + " ms left on cast");
                            LastInterrupt = DateTime.Now;
                        })
                    ),

                    //GOUGE
                    new Decorator(
                    ret =>
                        EnableInterrupting &&
                        EnableGougeInterrupt &&
                        IsAttackable(StyxWoW.Me.CurrentTarget) &&
                        StyxWoW.Me.CurrentTarget.IsCasting &&
                        StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                        StyxWoW.Me.CurrentTarget.CurrentCastTimeLeft.TotalMilliseconds < CastTimeLeftInMS &&
                        !StyxWoW.Me.IsBehind(StyxWoW.Me.CurrentTarget) &&
                        !IsCrowdControlled(StyxWoW.Me) &&
                        SpellManager.CanCast("Gouge") &&
                        LastInterrupt + TimeSpan.FromMilliseconds(500) < DateTime.Now,

                        new Action(delegate
                        {

                            SpellManager.Cast("Gouge");
                            Logging.Write("Gouge interrupt on " + StyxWoW.Me.CurrentTarget.Name + " with " + StyxWoW.Me.CurrentTarget.CurrentCastTimeLeft.TotalMilliseconds.ToString() + " ms left on cast");
                            LastInterrupt = DateTime.Now;
                        })
                    ),

                    //DEADLY THROW
                    new Decorator(
                    ret =>
                        EnableInterrupting &&
                        IsAttackable(StyxWoW.Me.CurrentTarget) &&
                        StyxWoW.Me.ComboPoints >= 3 &&
                        StyxWoW.Me.CurrentTarget.IsCasting &&
                        StyxWoW.Me.CurrentTarget.CanInterruptCurrentSpellCast &&
                        StyxWoW.Me.CurrentTarget.Distance <= 30 &&
                        StyxWoW.Me.CurrentTarget.CurrentCastTimeLeft.TotalMilliseconds < CastTimeLeftInMS &&
                        StyxWoW.Me.IsFacing(StyxWoW.Me.CurrentTarget) &&
                        !IsCrowdControlled(StyxWoW.Me) &&
                        !InterruptImmune(StyxWoW.Me.CurrentTarget) &&
                        SpellManager.CanCast("Deadly Throw") &&

                        LastInterrupt + TimeSpan.FromMilliseconds(500) < DateTime.Now,

                        new Action(delegate
                        {

                            SpellManager.Cast("Deadly Throw");
                            Logging.Write("Deadly Throw interrupt on " + StyxWoW.Me.CurrentTarget.Name + " with " + StyxWoW.Me.CurrentTarget.CurrentCastTimeLeft.TotalMilliseconds.ToString() + " ms left on cast");
                            LastInterrupt = DateTime.Now;
                        })
                    ),

                    //KIDNEY SHOT
                    new Decorator(
                    ret =>
                        EnableInterrupting &&
                        EnableKidneyShotInterrupt &&
                        IsAttackable(StyxWoW.Me.CurrentTarget) &&
                        StyxWoW.Me.CurrentTarget.IsCasting &&
                        StyxWoW.Me.ComboPoints >= 1 &&
                        StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                        StyxWoW.Me.CurrentTarget.CurrentCastTimeLeft.TotalMilliseconds < CastTimeLeftInMS &&
                        !IsCrowdControlled(StyxWoW.Me) &&
                        SpellManager.CanCast("Kidney Shot") &&
                        LastInterrupt + TimeSpan.FromMilliseconds(500) < DateTime.Now,

                        new Action(delegate
                        {

                            SpellManager.Cast("Kidney Shot");
                            Logging.Write(StyxWoW.Me.ComboPoints + "pt Kidney Shot interrupt on " + StyxWoW.Me.CurrentTarget.Name + " with " + StyxWoW.Me.CurrentTarget.CurrentCastTimeLeft.TotalMilliseconds.ToString() + " ms left on cast");
                            LastInterrupt = DateTime.Now;
                        })
                    ),

                    //SHIV WITH MIND NUMBING
                    new Decorator(
                    ret =>
                        EnableInterrupting &&
                        IsAttackable(StyxWoW.Me.CurrentTarget) &&
                        StyxWoW.Me.HasAura(5761) &&
                        StyxWoW.Me.CurrentTarget.IsCasting &&
                        StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                        StyxWoW.Me.CurrentTarget.IsCasting &&
                        !IsCrowdControlled(StyxWoW.Me) &&
                        SpellManager.CanCast("Shiv"),

                        new Action(delegate
                        {
                            SpellManager.Cast("Shiv");
                            Logging.Write("Mind Numbing Shiv on " + StyxWoW.Me.CurrentTarget.Name);
                        })
                    )


                );
        }
        #endregion
        #region Openers()

        public DateTime LastOpener;

        public Composite Openers()
        {
            return
                new Decorator(
                    ret =>
                        EnableOpeners &&
                        IsAttackable(StyxWoW.Me.CurrentTarget),
                        
                        new PrioritySelector(


                            //SAP
                            new Decorator(
                                ret =>
                                    EnableSapOpener &&
                                    StyxWoW.Me.CurrentTarget != null &&
                                    (!StyxWoW.Me.CurrentTarget.ActiveAuras.ContainsKey("Sap") && !StyxWoW.Me.CurrentTarget.ActiveAuras.ContainsKey("Cheap Shot")) &&
                                    IsAttackable(StyxWoW.Me.CurrentTarget) &&
                                    StyxWoW.Me.CurrentTarget.Distance <= 10 &&
                                    (StyxWoW.Me.CurrentTarget.IsHumanoid || StyxWoW.Me.CurrentTarget.IsBeast || StyxWoW.Me.CurrentTarget.IsDemon || StyxWoW.Me.CurrentTarget.IsDragon || StyxWoW.Me.CurrentTarget.IsPlayer) &&
                                    !StyxWoW.Me.CurrentTarget.Combat &&
                                    SpellManager.CanCast("Sap") &&
                                    EnemyUnitsInSap.Count() < 1,

                                new Action(delegate
                                {
                                    SpellManager.Cast("Sap");
                                    Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Sapped " + StyxWoW.Me.CurrentTarget.Name);
                                    //return RunStatus.Success;
                                })
                            ),

                            //CHEAP SHOT
                            new Decorator(
                                ret =>
                                EnableCheapShotOpener &&
                                StyxWoW.Me.Combat &&
                                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                                !StyxWoW.Me.CurrentTarget.ActiveAuras.ContainsKey("Cheap Shot") &&
                                SpellManager.CanCast("Cheap Shot"),

                                new Action(delegate
                                {
                                    SpellManager.Cast("Cheap Shot");
                                    Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Cheap Shot on " + StyxWoW.Me.CurrentTarget.Name);

                                    LastOpener = DateTime.Now;
                                    //return RunStatus.Success;
                                })
                            ),

                            //AMBUSH
                            new Decorator(ret =>
                                StyxWoW.Me.Combat &&
                                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                                StyxWoW.Me.IsBehind(StyxWoW.Me.CurrentTarget) &&
                                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                                SpellManager.CanCast("Ambush"),

                                new Action(delegate
                                {
                                    SpellManager.Cast("Ambush");
                                    Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Ambush on " + StyxWoW.Me.CurrentTarget.Name);
                                    LastOpener = DateTime.Now;
                                    //return RunStatus.Success;
                                })),

                            
                            //GARROTE
                            new Decorator(ret =>
                                EnableGarroteOpener &&
                                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                                StyxWoW.Me.CurrentTarget.ActiveAuras.ContainsKey("Cheap Shot") &&
                                StyxWoW.Me.Combat &&
                                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                                !HasMyAura("Garrote", StyxWoW.Me.CurrentTarget) &&
                                SpellManager.CanCast("Garrote"),

                                new Action(delegate
                                {
                                    SpellManager.Cast("Garrote");
                                    Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Garrote on " + StyxWoW.Me.CurrentTarget.Name);
                                    LastOpener = DateTime.Now;
                                    //return RunStatus.Success;
                                })
                            )
                            
                            

                        )
                );
        }

        #endregion
        #region Poisons
        public static bool NeedsPoison
        {
            get
            {
                return StyxWoW.Me.Inventory.Equipped.MainHand != null &&
                    StyxWoW.Me.Inventory.Equipped.MainHand.TemporaryEnchantment.Id == 0 &&
                    StyxWoW.Me.Inventory.Equipped.MainHand.ItemInfo.WeaponClass != WoWItemWeaponClass.FishingPole;
            }
        }

        public Composite ApplyPoisons()
        {
            return 
                new PrioritySelector(
                    new Decorator(
                    ret =>
                        NeedsPoison && !StyxWoW.Me.HasAura(MainHandPoison) && SpellManager.HasSpell(MainHandPoison),
                            new Action(delegate
                                {
                                    SpellManager.CastSpellById(MainHandPoison);
                                    Logging.Write(StyxWoW.Me.HealthPercent + "Applying Main Hand Poison");
                                }
                            )
                    ),
                    new Decorator(
                    ret =>
                        NeedsPoison && !StyxWoW.Me.HasAura(OffHandPoison) && SpellManager.HasSpell(OffHandPoison),
                            new Action(delegate
                                {
                                    SpellManager.CastSpellById(OffHandPoison);
                                    Logging.Write(StyxWoW.Me.HealthPercent + "Applying Off Hand Poison");
                                }
                            )
                    )
                );
        }
        #endregion

        #region PremeditationSliceandDice()
        public Composite PremeditationSliceandDice()
        {
            return
            new Decorator(
                ret =>
                EnablePremeditationSliceandDice &&
                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.CurrentTarget.Distance < 15 &&
                StyxWoW.Me.HasAura("Stealth") &&
                !StyxWoW.Me.HasAura("Slice and Dice") &&
                !IsCrowdControlled(StyxWoW.Me),

                new PrioritySelector(

                    //PREMED
                    new Decorator(
                        ret => 
                        StyxWoW.Me.CurrentTarget != null &&
                        StyxWoW.Me.ComboPoints < 1 &&
                        MyDebuffTime("Slice and Dice", StyxWoW.Me) < 5 &&
                        SpellManager.CanCast("Premeditation"),

                        new Action(delegate
                        {
                            SpellManager.Cast("Premeditation");
                            Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Premeditation on " + StyxWoW.Me.CurrentTarget);
                            //return RunStatus.Success;
                        })),

                    //SND
                    new Decorator(
                        ret => 
                        StyxWoW.Me.CurrentTarget != null &&
                        MyDebuffTime("Slice and Dice", StyxWoW.Me) < 5 &&
                        SpellManager.CanCast("Slice and Dice"),

                        new Action(delegate
                        {
                            SpellManager.Cast("Slice and Dice");
                            Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Slice and Dice");
                            //return RunStatus.Success;
                        }))
                )
            );

        }

        #endregion
        #region SapStealthy
        public Composite SapStealthy()
        {
            return

                new Decorator(
                ret =>
                    EnableSapStealthy &&
                    (
                        StyxWoW.Me.ActiveAuras.ContainsKey("Stealth") ||
                        StyxWoW.Me.ActiveAuras.ContainsKey("Shadow Dance") ||
                        StyxWoW.Me.ActiveAuras.ContainsKey("Subterfuge")
                    ) &&
                    FindStealthy.Count() >= 1,

                new Action(delegate
                {
                    WoWUnit StealthedTarget = FindStealthy.FirstOrDefault();
                    StealthedTarget.Target();
                    SpellManager.Cast("Sap");
                    Logging.Write(StyxWoW.Me.CurrentEnergy + "E " + StyxWoW.Me.ComboPoints + "P - " + "Sapped " + StealthedTarget.ToString() + " ms left on cast: " + StealthedTarget.CurrentCastTimeLeft.Milliseconds);
                }
                )
            );
        }
        #endregion
        
        #region Shiv
        public Composite Shiv()
        {
            return
            new Decorator(ret =>
                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.Combat &&
                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                !StyxWoW.Me.HasAura("Stealth") &&
                SpellManager.CanCast("Shiv") &&
                !IsImmune(StyxWoW.Me.CurrentTarget) &&
                (
                    StyxWoW.Me.CurrentTarget.HasAura("Enrage") ||
                    StyxWoW.Me.CurrentTarget.HasAura("Wrecking Crew") ||
                    StyxWoW.Me.CurrentTarget.HasAura("Savage Roar") ||
                    StyxWoW.Me.CurrentTarget.HasAura("Unholy Frenzy") ||
                    StyxWoW.Me.CurrentTarget.HasAura("Berserker Rage") ||
                    StyxWoW.Me.CurrentTarget.HasAura("Death Wish") ||
                    StyxWoW.Me.CurrentTarget.HasAura("Owlkin Frenzy") ||
                    StyxWoW.Me.CurrentTarget.HasAura("Bastion of Defense")
                ),

                new Action(delegate
                {
                    SpellManager.Cast("Shiv");
                    Logging.Write(StyxWoW.Me.HealthPercent + "% - Shiv " + StyxWoW.Me.CurrentTarget.Name);
                }
                )
            );
        }

        #endregion
        #region WillOfTheForsaken()

        public static bool UseWOTF
        {
            get
            {
                return StyxWoW.Me.ActiveAuras.Any(a =>
                    a.Value.Spell.Mechanic == WoWSpellMechanic.Charmed ||
                    a.Value.Spell.Mechanic == WoWSpellMechanic.Fleeing ||
                    a.Value.Spell.Mechanic == WoWSpellMechanic.Horrified ||
                    a.Value.Spell.Mechanic == WoWSpellMechanic.Asleep
                );
            }
        }

        public Composite WillOfTheForsaken()
        {
            return
            new Decorator(ret =>
                EnableWillOfTheForsaken &&
                StyxWoW.Me.Race == WoWRace.Undead &&
                StyxWoW.Me.Combat &&
                SpellManager.CanCast(7744) &&
                UseWOTF,

                new Action(delegate
                {
                    SpellManager.Cast(7744); //Will of the Forsaken
                    Logging.Write("Will of the Forsaken");
                }));
        }

        #endregion
        #region DisableAutoAttack()
        public Composite DisableAutoAttack()
        {
            return
                new Decorator(
                ret =>
                    (
                    //StyxWoW.Me.CurrentTarget != null &&
                    //StyxWoW.Me.ActiveAuras.ContainsKey("Stealth") && 
                    StyxWoW.Me.IsAutoAttacking &&
                    !StyxWoW.Me.Combat
                    //!StyxWoW.Me.CurrentTarget.IsWithinMeleeRange && 
                    
                    ),

                        new Action(delegate
                        {
                            StyxWoW.Me.ToggleAttack();
                            Logging.Write(StyxWoW.Me.HealthPercent + "% - Toggle Auto Attack");
                        }
                        )
            );
        }
        #endregion
        #region Rupture()
        public Composite Rupture()
        {
            return
            new Decorator(ret =>
                StyxWoW.Me.CurrentTarget != null &&
                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.Combat &&
                (
                    MyDebuffTime("Rupture", StyxWoW.Me.CurrentTarget) < 2 || 
                    MyDebuffTime("Garrote", StyxWoW.Me.CurrentTarget) < 2

                    ) &&
                !IsImmune(StyxWoW.Me.CurrentTarget) &&
                !StyxWoW.Me.HasAura("Subterfuge") &&
                StyxWoW.Me.ComboPoints >= 2 &&
                StyxWoW.Me.ComboPoints <= 5 &&
                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                SpellManager.CanCast("Rupture"),

                        new Action(delegate
                        {
                            SpellManager.Cast("Rupture");
                            Logging.Write(StyxWoW.Me.ComboPoints + "pt rupture on " + StyxWoW.Me.CurrentTarget.Name);
                        }
                        )
            );
        }

        #endregion
        #region SubterfugeEndingCheapShot()
        public Composite SubterfugeEndingCheapShot()
        {
            return
            new Decorator(ret =>
                IsAttackable(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.Combat &&
                !StyxWoW.Me.CurrentTarget.HasAura("Cheap Shot") &&
                MyDebuffTime("Subterfuge", StyxWoW.Me) <= 1 &&
                !IsImmune(StyxWoW.Me.CurrentTarget) &&
                StyxWoW.Me.CurrentTarget.IsWithinMeleeRange &&
                SpellManager.CanCast("Cheap Shot"),

                        new Action(delegate
                        {
                            SpellManager.Cast("Cheap Shot");
                            Logging.Write("Cheap Shot before Subterfuge wears off on " + StyxWoW.Me.CurrentTarget.Name);
                        }));
        }

        #endregion
        #region ToggleEnableAutoStealth()

        public DateTime LastToggleStealth;

        public Composite ToggleEnableAutoStealth()
        {

        return
            new PrioritySelector(
                new Decorator(ret => EnableAlwaysStealth && (LastToggleStealth  + TimeSpan.FromMilliseconds(1500)) < DateTime.Now, 
                    new Action(delegate
                        {
                        EnableAlwaysStealth = false;
                        Logging.Write("Disabled Auto Stealth");
                        LastToggleStealth = DateTime.Now;
                        })),
                new Decorator(ret => !EnableAlwaysStealth && (LastToggleStealth + TimeSpan.FromMilliseconds(1500)) < DateTime.Now, 
                    new Action(delegate
                        {
                        EnableAlwaysStealth = true;
                        Logging.Write("Enabled Auto Stealth");
                        LastToggleStealth = DateTime.Now;
                        }))
            );

        }
        #endregion
        #region Tricks()
        public Composite Tricks()
        {
            WoWPlayer PlayerNeedingTricks =
            (from player in ObjectManager.GetObjectsOfType<WoWPlayer>()
            where player.GetAllAuras().Any(a => _dpsIncreaseAurasTypes.Contains(a.ApplyAuraType))
            select player).FirstOrDefault();
            
            return
            new Decorator(ret =>
                EnableTricks &&
                PlayerNeedingTricks != null &&
                PlayerNeedingTricks.Combat &&
                PlayerNeedingTricks.IsInMyPartyOrRaid &&
                PlayerNeedingTricks != StyxWoW.Me &&
                PlayerNeedingTricks.InLineOfSpellSight &&
                SpellManager.CanCast("Tricks of the Trade"),

                new Action(delegate
                {
                    SpellManager.Cast("Tricks of the Trade", PlayerNeedingTricks);
                    Logging.Write("Casting Tricks on" + PlayerNeedingTricks);
                }
                )
            );
        }

        #endregion
        #region UseHealthstone
        public Composite UseHealthstone()
        {
            return new Decorator(
                ret =>
                    StyxWoW.Me.Combat &&
                    StyxWoW.Me.HealthPercent < 25,
                new Action(delegate
                {
                    WoWItem hs = StyxWoW.Me.BagItems.FirstOrDefault(o => o.Entry == 5512);//5512 Healthstone
                    if (hs != null && hs.CooldownTimeLeft.TotalSeconds <= 0)
                    {
                        hs.Use();
                        Logging.Write(StyxWoW.Me.HealthPercent + "% - Healthstone");
                    }

                })
            );
        }
        #endregion



        

    }
}
